import g4p_controls.*;        //For the UI building
import java.awt.Font;         //For fonts, otherwise the UI looks crappy
import processing.serial.*;  //For the serial communication

private static final int FREQ_MHZ = 8;   //Frequency in MHz of the counter
private static final int SCALER = 1;     //Counter scaler
private static final float EPS =0.1;

// Declare variables for pictures
PImage img;  
PImage img2; 

//For serial communication
int counter, distance, filt, low, high;
int byte1, byte2, byte3, byte4;
Serial myPort; 

public void setup(){
  //Set serial communication
  String portName = Serial.list()[1];
  println("Port Name "+ portName); 
  myPort = new Serial(this, "COM6", 9600);

  //Set UI
  size(900,400);
  background(242, 242, 242);
  createGUI();
  
  //Set font
  Font f =new Font("Dialog", Font.BOLD, 80);
  textfield1.setFont(f);
  Font fu =new Font("Dialog", Font.BOLD, 40);
  label1.setFont(fu);
  
  // Load the images into the program 
  img = loadImage("Stop.jpg");  
  img2 = loadImage("Go.jpg");   
  
}

public void draw(){
   while( myPort.available() > 0) {  // If data is available,
    byte1 = byte2;
    byte2 = byte3;
    byte3 = byte4;
    byte4 = low;
    low = high;
    high = myPort.read();        
    
    if ((byte1 == 1) & (byte2 == 2) & (byte3 == 3) & (byte4 ==4)){
      //Reset the preamble.
      byte1=byte2=byte3=byte4=0;
      counter = ((256*high)+low);
      println("Counter is "+ counter);
      //Filter
      filt = int((1-EPS)*filt+EPS*counter);
      textfield1.setText(getMeasurementValue(filt) + " cm");        //Print Sonar value to the textfield
    
      /*  if (filt < 3) {          //Tried the if else pic loop here first, this will not work as filt is string
          image(img, 0, 0);
       }
  
      else {
      image(img2, 0, 0);   
       }*/
}
  }
}

public String getMeasurementValue(int counter){
  int us = counter*SCALER/FREQ_MHZ;//microseconds
  float cm = us/58;
  println ("Distance is : "+cm +" cm");
   
           if (cm < 3) {                  //if the distance to obstacle is less than 3cm
          image(img, 20, 150);            //Display stop sign
         }
  
          else {                          //otherwise
          image(img2, 20, 150);           //display Go sign
          }
      
    
    return Float.toString(cm);
  }
